"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModalContainer = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var events_1 = require("./events");
var common_1 = require("./helpers/common");
var ModalContainer = function () {
    var _a = react_1.useState([]), containers = _a[0], setContainers = _a[1];
    events_1.useSubscribeAddPortal(function (container) {
        setContainers(function (prev) { return __spreadArrays(prev, [container]); });
        container.blockBodyScroll && common_1.blockBodyScroll(true);
    });
    events_1.useSubscribeRemovePortal(function (containerId) {
        return setContainers(function (prev) { return prev.filter(function (container) { return container.containerId !== containerId; }); });
    });
    react_1.useEffect(function () {
        var hasBodyScroll = containers.reduce(function (has, container) {
            return has || container.blockBodyScroll;
        }, false);
        if (!hasBodyScroll)
            common_1.blockBodyScroll(false);
    }, [containers]);
    var modalPortals = containers.map(function (container) { return container.portal; });
    return jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: modalPortals }, void 0);
};
exports.ModalContainer = ModalContainer;
