"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSubscribeAddPortal = exports.useAddPortal = exports.ADD_PORTAL_EVENT = void 0;
var eventelo_1 = require("eventelo");
var react_1 = require("react");
exports.ADD_PORTAL_EVENT = "ADD_PORTAL_EVENT";
var useAddPortal = function () {
    var emit = eventelo_1.useEmit().emit;
    var overrideEmit = function (container) {
        emit(exports.ADD_PORTAL_EVENT, container);
    };
    return overrideEmit;
};
exports.useAddPortal = useAddPortal;
var useSubscribeAddPortal = function (callback) {
    var _a = eventelo_1.useSubscriber(), subscribe = _a.subscribe, unsubscribe = _a.unsubscribe;
    react_1.useEffect(function () {
        var key = subscribe(exports.ADD_PORTAL_EVENT, callback);
        return function () {
            unsubscribe(key);
        };
    }, []);
};
exports.useSubscribeAddPortal = useSubscribeAddPortal;
