"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSubscribeRemovePortal = exports.useRemovePortal = exports.REMOVE_PORTAL_EVENT = void 0;
var eventelo_1 = require("eventelo");
var react_1 = require("react");
exports.REMOVE_PORTAL_EVENT = "REMOVE_PORTAL_EVENT";
var useRemovePortal = function () {
    var emit = eventelo_1.useEmit().emit;
    var overrideEmit = function (id) {
        emit(exports.REMOVE_PORTAL_EVENT, id);
    };
    return overrideEmit;
};
exports.useRemovePortal = useRemovePortal;
var useSubscribeRemovePortal = function (callback) {
    var _a = eventelo_1.useSubscriber(), subscribe = _a.subscribe, unsubscribe = _a.unsubscribe;
    react_1.useEffect(function () {
        var key = subscribe(exports.REMOVE_PORTAL_EVENT, callback);
        return function () {
            unsubscribe(key);
        };
    }, []);
};
exports.useSubscribeRemovePortal = useSubscribeRemovePortal;
